

<h1 align="center">Graphene-CRUDDALS</h1>
<div align="center">

👩🏽‍💻 🚀 👨🏽‍💻  
**Build your own library to streamline trivial code for CRUD operations.**  

[![PyPI](https://img.shields.io/pypi/v/graphene-cruddals?style=flat-&color=00559c&label=pypi&logo=python&logoColor=white)](https://pypi.org/project/graphene-cruddals/)
[![GitHub License](https://img.shields.io/github/license/juanjcardona13/graphene-cruddals?style=flat&color=4c1)](https://github.com/juanjcardona13/graphene-cruddals/blob/main/LICENSE)  
[![Codecov](https://img.shields.io/codecov/c/gh/juanjcardona13/graphene-cruddals)](https://app.codecov.io/gh/juanjcardona13/graphene-cruddals)
  


<sub>Built with ❤︎ by [Juan J Cardona](https://github.com/juanjcardona13)</sub>


</div>

## 📋 Table of Contents

1. 🚀 [Getting started](#getting-started)
2. 👩‍💻 [Usage](#usage)
3. 📜 [License](#license)
4. 📞 [Contact](#contact)
5. 🙏 [Acknowledgements](#acknowledgements)



## <a name="getting-started">🚀 Getting started</a>

### Prerequisites

You need to have installed Python and pip. You can download Python from [here](https://www.python.org/downloads/).
Additionally, you need to have a good knowledge of how GraphQL and Graphene work.

### Installation

You can install this package using pip:

```bash
pip install graphene-cruddals
```

## <a name="usage">👩‍💻 Usage</a> 

An example of how to use this library is shown in this project: [Graphene-Django-CRUDDALS](https://github.com/juanjcardona13/graphene_django_cruddals)

This library is designed to help you build your own library to streamline trivial code for CRUD operations. It receives a normal Python dictionary, along with a set of utilities to know how the transformation of the fields should be done. It is not designed to be used directly, but to help you build your own library. For example, you can use it to build a library like Graphene-Django-CRUDDALS, which transforms a Django model into a Graphene schema. Graphene-Django-CRUDDALS library only works for Django, so you can use this library to build a library that works with any framework or ORM, like SQLAlchemy, Pydantic, etc.
If you need more information, you can ask me.

## <a name="license">📜 License</a>

Distributed under the Apache 2.0 License. See [LICENSE](https://github.com/juanjcardona13/graphene_cruddals/blob/main/LICENSE) for more information.

## <a name="contact">📞 Contact</a>

If you want to contact me you can reach me at the following email, LinkedIn or GitHub, I'll be happy to talk to you.

- [Email](mailto:juanjcardona13@gmail.com)
- [LinkedIn](https://www.linkedin.com/in/juanjcardona/)
- [GitHub](https://github.com/juanjcardona13)

## <a name="acknowledgements">🙏 Acknowledgements</a>

- [Python](https://www.python.org/)
- [Graphene ](https://docs.graphene-python.org/projects/django/en/latest/)
